# coding: utf-8
# Program to create a context tree weighting
# From an original in Fortran 90
# Fraga 15/07/2015

import math
import sys


def do_assert( condition, s ) :
	if condition==0 :
		print "***** ERROR, ASSERTION VIOLATED *****"
		print "*** PROGRAMING BUG ***"
		print "*** The assertion string is: ", s
		sys.exit(2)

def	prob_estimation1(self, c, s) :
	num = c[s] + self.beta
	den = 0.0

	i = 0
	while i < self.alphabet_predict :
		den += c[i] + self.beta
		i += 1

	return( num/den )

def count_total1( self, nodo ) :
	suma = 0
	i = 0
	while i < self.alphabet_predict :
		suma += nodo.counts[i]
		i += 1

	return suma

def attach_child(n, c, s) :
	
	if n.children[s] != 0 :
		do_assert( 0, "Attempted to attach a node in a place where it existed already" )

	n.children[s] = c

def is_tail( n ) :
	a = n.tail_location != -2
	return a 

def child_exists( n, s ) :
	if n == 0 :
		print "ERROR: node does not exists in child_exist()"
		sys.exit(1)

	if n.children[s] == 0 :
		return False
	else :
		return True

def child_at( n, s ) :
	do_assert( child_exists( n, s ), "OPPS tried to get non-existen child" )

	return( n.children[s] )

def is_terminal1( self, n ) :
	i = 0
	while i < self.alphabet :
		if child_exists( n, i ) == True :
			return False
		i += 1

	return True

def sum_children_Lw1 ( self, n ) :
	suma = 0.0
	i = 0
	while i<self.alphabet :
		c = n.children[i]
		if c != 0:
			suma += c.Lw
		i += 1

	return suma

def avg_log_probs( l1, l2 ) :
	v = 0.0
	if l1 < l2 :
		u = 1.0 + math.pow(2.0, l1-l2 )
		w = math.log(u)*1.44269504088896340
		v = l1 + 1.0 - w
	else :
		u = 1.0 + math.pow(2.0, l2-l1 )
		w = math.log(u)*1.44269504088896340
		v = l2 + 1.0- w

	return v
		

def add_observation1( self, n, s ) :
	phat = prob_estimation1( self, n.counts, s )

	n.Le -= math.log(phat)*1.44269504088896340
	n.counts[s] += 1

	if is_terminal1(self, n) == True :
		n.Lw = n.Le
	else :
		sumc = sum_children_Lw1(self, n )
		n.Lw = avg_log_probs( float(n.Le), float(sumc) )

def expand_tail1( self, n ) :
	past = 0
	if n.tail_location >= 1 :
		past = self.x[n.tail_location]
	else : 
		past = self.epsilon

	m = child_exists( n, past)
	if child_exists( n, past) == True : 
		do_assert( 0, "Tail node must not have a real child" )

	c = Node()
	c.Le = n.Le
	c.Lw = n.Lw
	i=0
	while i<self.alphabet_predict  :
		c.counts[i] = n.counts[i]
		i += 1

	if n.tail_location >= 0 :
		c.tail_location = n.tail_location - 1
	else :
		c.tail_location = -2

	attach_child( n, c, past )
	# n.children[past] = c
	n.tail_location = -2

def update_tree1( self, n, s, j ) :

	if is_tail(n) == True :
		expand_tail1( self, n )

	if j >= 0 :
		past = 0
		if j >= 1 :
			past = self.x[j]
		else :
			past = self.epsilon

		if child_exists( n, past ) == False :
			c = Node()
			if j == -1 :
				print "Error!  Tried to set tail location to -2.  There is a bug. Bad dog."
				sys.exit(6)

			c.tail_location = j-1
			add_observation1( self, c, s )
			
			# attach_child( n, c, past )
			if n.children[past] != 0 :
				do_assert( 0, "Attempted to attach a node in a place where it existed already" )

			n.children[past] = c
		else :
			# donde = child_at(n, past) 
			# self.prof += 1
			update_tree1( self, n.children[past], s, j-1 )

	add_observation1(self, n, s )
			
		
class Tree:
	def __init__( self ) :
		self.alphabet = 0
		self.alphabet_predict = 0
		self.epsilon = 0
		self.beta = 0
		self.N = 0
		self.x = []
		self.top = 0                 # Start of the tree

	do_assert1 = do_assert
	prob_estimation = prob_estimation1
	is_terminal = is_terminal1
	count_total = count_total1
	sum_children_Lw = sum_children_Lw1
	expand_tail  = expand_tail1
	update_tree = update_tree1
	add_observation = add_observation1



class Node:
	def __init__(self) :
		self.Le = 0.0
		self.Lw = 0.0
		self.counts = [0,0]
		self.children = [0,0,0]   # pointers to children nodes
		self.tail_location = -2


